#
# Generated by SM2Gen version:0.8 Chameleon version:4.5.4 On Python:3.12.3 at 2024-11-04 16:03:10 
#
#
# Routines to be edited by the developer to provide validation for parameters
# and provison of the control data for table(s)
#
use esmith::util;
use esmith::HostsDB;
use esmith::AccountsDB;
use esmith::NetworksDB;
use esmith::HostsDB;
use esmith::DomainsDB;

#use Net::SSLeay;

#The most common ones
our $cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
our $adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
our $ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
our $hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
our $ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");

# Validation routines - parameters for each panel

	sub validate_LIST {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}

	sub validate_PARAMS {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}

	sub validate_CHECKALLDOMAINS {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}

	sub validate_CHECKALLENABLEDDOMAINS {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}


# Get singleton data for each panel

	sub get_data_for_panel_LIST {
		# Return a hash with the fields required which will be loaded into the shared data 
		my $c = shift;
#		my ($reply, $err, $server_cert) = Net::SSLeay::sslcat('localhost', 443, '/');
#		my $issuer = Net::SSLeay::X509_NAME_oneline(Net::SSLeay::X509_get_issuer_name($server_cert));
#		my $before = Net::SSLeay::P_ASN1_TIME_get_isotime(Net::SSLeay::X509_get_notBefore($server_cert));
#		my $expiry = Net::SSLeay::P_ASN1_TIME_get_isotime(Net::SSLeay::X509_get_notAfter($server_cert));

		my %ret = (
			'Data1'=>'Data for LIST', #Example
			# fields from Inputs in LIST $fields['LIST']
			'InternalIP'=>$cdb->get_prop('InternalInterface','IPAddress'),
			'ExternalIP'=>$cdb->get_prop('ExternalInterface','IPAddress'),
			'InternetIP'=>"ext ip", #get_my_ip()
			'Issuer'=>'$issuer',
			'Expiry'=>'$expiry',
			'NotBefore'=>'$before',
		);
		return %ret;
	}

	sub get_data_for_panel_PARAMS {
		# Return a hash with the fields required which will be loaded into the shared data 
		my $c = shift;
		my %ret = (
			'Data1'=>'Data for PARAMS', #Example
			# fields from Inputs in PARAMS $fields['PARAMS']
			
				'status'=>'status contents',
			
				'hookScript'=>'hookScript contents',
			
				'hostOverride'=>'hostOverride contents',
			
				'ACCEPT_TERMS'=>'ACCEPT_TERMS contents',
			
				'API'=>'API contents',
			
				'keysize'=>'keysize contents',
			
				'configure'=>'configure contents',
			
			
		);
		return %ret;
	}

	sub get_data_for_panel_CHECKALLDOMAINS {
		# Return a hash with the fields required which will be loaded into the shared data 
		my $c = shift;
		my %ret = (
			'Data1'=>'Data for CHECKALLDOMAINS', #Example
			# fields from Inputs in CHECKALLDOMAINS $fields['CHECKALLDOMAINS']
			
				'AllDomainsCheck'=>'AllDomainsCheck contents',
			
			
		);
		return %ret;
	}

	sub get_data_for_panel_CHECKALLENABLEDDOMAINS {
		# Return a hash with the fields required which will be loaded into the shared data 
		my $c = shift;
		my %ret = (
			'Data1'=>'Data for CHECKALLENABLEDDOMAINS', #Example
			# fields from Inputs in CHECKALLENABLEDDOMAINS $fields['CHECKALLENABLEDDOMAINS']
			
				'EnabledDomainsCheck'=>'EnabledDomainsCheck contents',
			
			
		);
		return %ret;
	}


	
# Get control data for table(s)

	sub get_DomainList {
		# Return an array of hashes of the contents for each row and column for DomainList
		# default is a single row of strings "col1header-1, col2header-1, col3Header-1 etc"
		my $c = shift;
		my $control_data = $c->stash('DomainList');
		#my @ret = {};
		
		my @list = ();
#		my @rv = Net::SSLeay::X509_get_subjectAltNames($server_cert);
#		foreach my $element (@rv) {
#		 next if $element  =~ /^\d+$/; ;
#		 #print $element . "\n";
#		 push @list, $element;
#		}

		my @data = ();
		my $check = $c->l('CHECK');
		
		for ($ddb->domains)
		{
			my $ns = $_->prop('Nameservers') || 'internet';
			my $le = $_->prop('letsencryptSSLcert') || 'disabled';#letsencrypt configure all
			my $dname= $_->key;
			my $isincert = "N";
			my $check = $c->l('lets_CHECK');
			$isincert = "Y" if ( $dname ~~ @list);
			# domain
			push @data, 
				{ Domain => $_->key, 
				  $_->props,  
				  letsencryptSSLcert => $le, 
				  isincert => $isincert,
				  Check => $check, 
				  Nameservers => $ns,
			   };
			#and hosts 
			for my $h ($hdb->get_hosts_by_domain($dname))
			{
				next if $ddb->get($h->key);
				next unless ($h->prop('HostType') eq "Self" || $h->prop('HostType') eq "Local");
				$le = $h->prop('letsencryptSSLcert') || 'disabled';#letsencrypt configure all
				$isincert = "N";
				$isincert = "Y" if ( $h->key ~~ @list);
				push @data,
				  { Domain => "--> ". $h->key, 
					 $h->props,
					 Description=>$h->prop('ExternalIP')|| $h->prop('InternalIP')||"",
					Content => $h->prop('HostType'),
					isincert => $isincert,
					Check => $check, 
					Nameservers => $c->l($ns),
				  }
			}
		}
		return \@data;
	}


# Return hash with values from row in which link clicked on table

	sub get_selected_LIST {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return $ret;
	}

	sub get_selected_PARAMS {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return $ret;
	}

	sub get_selected_CHECKALLDOMAINS {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return $ret;
	}

	sub get_selected_CHECKALLENABLEDDOMAINS {
		my $c = shift;
		my $selected = shift; #Parameter is name of selected row.
		my $is_new_record = shift; #Indicates new record required (defaults)
		my %ret = {};
		return $ret;
	}


#after sucessful modify or create or whatever and submit then perfom (if the params validate)

	sub perform_LIST {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}

	sub perform_PARAMS {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}

	sub perform_CHECKALLDOMAINS {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}

	sub perform_CHECKALLENABLEDDOMAINS {
		my $c = shift;
		my $prefix_data = shift; #Data hash as parameter
		my $ret = 'ok';
		return $ret;
	}


sub create_link{
	# WIP
	my ($c,$route, $panel, $index) = shift;
	my $link = "$route?trt=$panel&Selected=$index";
	return $link;
}
1;